import { PaintedNode } from "parsegraph-artist";
import Navport from "./Navport";
import { Projector } from "parsegraph-projector";
import { FocusInput, TouchInput, MouseInput, KeyInput } from "parsegraph-input";
import NavportCursor from "./NavportCursor";
import NavportKeyController from "./NavportKeyController";
import NavportMouseController from "./NavportMouseController";
import NavportImpulse from "./NavportImpulse";
export declare const TOUCH_SENSITIVITY = 1;
export declare const MOUSE_SENSITIVITY = 1;
export declare const SLIDER_NUDGE = 0.01;
export declare const INPUT_LAYOUT_TIME = 15;
declare class Input {
    _mainContainer: HTMLElement;
    _domContainer: HTMLElement;
    _focus: FocusInput;
    _touch: TouchInput;
    _mouse: MouseInput;
    _key: KeyInput;
    constructor(mainContainer: HTMLElement, domContainer: HTMLElement);
    mouse(): MouseInput;
    touch(): TouchInput;
    key(): KeyInput;
    focus(): FocusInput;
    mainContainer(): HTMLElement;
    domContainer(): HTMLElement;
}
export default class InputController {
    _nav: Navport;
    _cursor: NavportCursor;
    _key: NavportKeyController;
    _mouse: NavportMouseController;
    _showCursor: boolean;
    _inputs: Map<Projector, Input>;
    _impulse: NavportImpulse;
    constructor(nav: Navport);
    mouse(): NavportMouseController;
    key(): NavportKeyController;
    impulse(): NavportImpulse;
    cursor(): NavportCursor;
    carousel(): import("..").Carousel;
    scheduleRepaint(): void;
    camera(): import("parsegraph-camera").default;
    width(): number;
    height(): number;
    focusedNode(): PaintedNode;
    menu(): import("./BurgerMenu").default;
    nav(): Navport;
    world(): PaintedNode;
    resetCamera(complete?: boolean): void;
    handleEvent(eventType: string, eventData: any, proj: Projector): boolean;
    update(t: Date): boolean;
    paint(projector: Projector): boolean;
    render(proj: Projector): boolean;
}
export {};
//# sourceMappingURL=InputController.d.ts.map